//Sudoku Solver and Generator with grid display in terminal..
#include<iostream>
#include<fstream>
#include<cstdlib>
using namespace std;

int Sudoku[9][9];
void display();
int checkRow(int n,int i)//checks possibility in row
{
    for(int j=0;j<9;j++)
    if(Sudoku[i][j]==n)
    return 0;
    return 1;
}
int checkColumn(int n,int j)//checks possibility in column
{
    for(int i=0;i<9;i++)
    if(Sudoku[i][j]==n)
    return 0;
    return 1;
}

int checkBox(int n,int i,int j)//checks possibility in box
{
    int row=i-(i%3);
    int col=j-(j%3);
    for(i=row;i<row+3;i++)
    for(j=col;j<col+3;j++)
    if(Sudoku[i][j]==n)
    return 0;
    return 1;
}

int sudokuSolved()//checks if sudoku solved
{
    for(int i=0;i<9;i++)
    for(int j=0;j<9;j++)
    if(Sudoku[i][j]==0)
    return 1;
    return 0;
}

int canBox(int no,int bm,int bn,int m,int n)//Checks the probability of a number in various spaces in a 3*3 box
{
	bm=bm*3;bn =bn*3;
	if(!checkBox(no,bm,bn))
    return 0;
	for(int i=bm;i<bm+3;i++)
	for(int j=bn;j<bn+3;j++)
    {
		if(!(i==m||j==n))
		{
			if(checkRow(no,i)&&checkColumn(no,j))
            return 1;
		}
    }
    return 0;
}

void sudokuSolver()//solves sudoku
{
    int count=0;int num=0;int row=0,col=0;int counti=0,countj=0,posi=0,posj=0,change=0;
    do
    {
       row=0;
       col=0;
       if(change==0)
       {
           for(int i=0;i<9;i++)
           for(int j=0;j<9;j++)
           {
                count=0;num=0;
                if(Sudoku[i][j]==0)
                {
                    for(int k=1;k<=9;k++)
                         if(checkBox(k,i,j)&&checkRow(k,i)&&checkColumn(k,j))
                         {
                         num=k;count++;
                         }       
                         if(count==1)
                         {
                              Sudoku[i][j]=num;change++;}
                         }
                    }
                }
                int flag=0;
                if(change==0)
                {
                    for(int i=0;i<9;i++)
                    for(int j=0;j<9;j++)
                    {
                        count=0;num=0;
                        if(Sudoku[i][j]==0)
                        {
                        for(int k=1;k<=9;k++)
                        {
                            flag=0;
                            if(checkBox(k,i,j)&&checkRow(k,i)&&checkColumn(k,j))
                            {
	                             for(int l=0;l<3;l++)
                                 {
	                                 if(l!=i/3)
                                     if(canBox(k,l,j/3,i,j))flag=1;
                                 }
                                 for(int l=0;l<3;l++)
                                 {
	                                 if(l!=j/3)
	                                 if(canBox(k,i/3,l,i,j))flag=1;
                                 }
                                 if(flag==0){num=k;count++;
                            }
                        }
                    }
                    if(count==1){Sudoku[i][j]=num;change++;}
                }
           }
       }

       if(change==0)
       {
            for(int i=0;i<9;i++)
            for(int j=0;j<9;j++)
            {
                count=0;num=0;
                if(Sudoku[i][j]==0)
                {
                     for(int k=1;k<=9;k++)
                     if(checkBox(k,i,j)&&checkRow(k,i)&&checkColumn(k,j))
                     {
	                 count=0;
	                 for(int l=(i/3)*3;l<(i/3)*3+3;l++)
	                 for(int m=(j/3)*3;m<(j/3)*3+3;m++)
                     {
                         if(Sudoku[l][m]==0)
	                     if(checkRow(k,l)&&checkColumn(k,m)&&checkBox(k,l,m)){cout<<i<<j<<k<<" ";count++;}
                     }
                     if(count==1){Sudoku[i][j]=k;change++;break;}
                }
            }
        }
    }

    if(change==0)
    return;
    change=0;

    while(col<=6)
    {
         for(int k=1;k<=9;k++)
         {
             counti=0;countj=0;posi=0;posj=0;
             for(int j=col;j<col+3;j++)
             if(checkColumn(k,j)){countj++;posj=j;}
             if(countj==1)
             {
                 for(int i=0;i<9;i++)
                 {
                     if(Sudoku[i][posj]==0)
                     {
                         if(checkBox(k,i,posj))
                         {
                             if(checkRow(k,i)){counti++;posi=i;
                         }
                     }
                 }
             }
             if(counti==1)
             {
                  Sudoku[posi][posj]=k;change++;}
             }
         }
         col=col+3;
    }
    while(row<=6)
    {
         for(int k=1;k<=9;k++)
         {
             counti=0;countj=0;posi=0;posj=0;
             for(int i=row;i<row+3;i++)
             if(checkRow(k,i)){counti++;posi=i;}
             if(counti==1)
             {
                  for(int j=0;j<9;j++)
                  {
                       if(Sudoku[posi][j]==0)
                       {
                           if(checkBox(k,posi,j))
                           {
                                if(checkColumn(k,j)){countj++;posj=j;}
                           }
                       }                   
                  }
                  if(countj==1)
                  {
                       Sudoku[posi][posj]=k;change++;}
                  }
             }
             row=row+3;
         }
    }
    while(sudokuSolved());//checks if the sudoku is solved or not
    return;
}




int main()//main function for user
{
    int choice,ch;
    cout<<"Welcome to Sudoku IIT"<<endl;
    cout<<"Please select your choice"<<endl;
    cout<<"Type 1 for Sudoku Solver"<<endl;
    cout<<"Type 2 for Sudoku Game"<<endl;
    cin>>choice;

int spaces;
ifstream f1;
ifstream f2;
ofstream f3;
ofstream f4;
   switch(choice)
   {
       int i,j;        
       case 1:
           cout<<"Welcome to Sudoku Solver"<<endl;
           srand(time(0));
          
           char sud[12];
           strcpy(sud,"sudoku");
           sud[6]=rand()%6+1+48;
           cout<<"Sudoku number :- "<<sud[6]<<endl;
           sud[7]='.';
           sud[8]='t';
           sud[9]='x';
           sud[10]='t';
           sud[11]='\0';
    
    f1.open(sud);//Calls an unsolved sudoku randomly
    for(i=0;i<9;i++)
    {
       for(j=0;j<9;j++)
       {
           f1>>Sudoku[i][j];
       }
    }
    display();
    f1.close();
    cout<<endl;
    cout<<"Processing......"<<endl;
    sudokuSolver();
    cout<<endl;
    cout<<"solution of the above Sudoku is:"<<endl;
    
    display();//Displays the Unsolved Sudoku in a grid
    break;
    
    case 2:
    srand(time(0));     
    cout<<"Sudoku game"<<endl;     
    char sudsolved[18];
    strcpy(sudsolved,"sudokusolved");
    sudsolved[12]=rand()%10+1+48;
    cout<<"Sudoku number :- "<<sudsolved[12]<<endl;
    sudsolved[13]='.';
    sudsolved[14]='t';
    sudsolved[15]='x';
    sudsolved[16]='t';
    sudsolved[17]='\0';
    f2.open(sudsolved);
    for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
              ch=f2.get();
              if(f2.eof())
                   break;
              if(ch!='\n')
              Sudoku[i][j]=ch-48;                                  
              else
              j--;
        }  
    }
    char solsudoku[13];
    strcpy(solsudoku,"Solutionsudoku.txt\0");
    f4.open(solsudoku);//Copies the sudoku in a file for use in graphics(not anymore)
    for(i=0;i<9;i++)
    {
         f4<<endl;
         for(int j=0;j<9;j++)
         {
             f4<<Sudoku[i][j]<<"  ";
         }
    }
    display();
    f4.close();
    f2.close();
    cout<<endl;
    cout<<"Please enter total number of spaces you would like"<<endl;
    cin>>spaces;
    while(spaces>40)
    {
    cout<<"Please enter a valid entry"<<endl;
    cin>>spaces;
    }
    while(spaces>0 && spaces<40)//Generates a sudoku with random spaces
    {
        int row=rand()%9;
        int col=rand()%9;
        if(Sudoku[row][col]!=0)
        {
          Sudoku[row][col]=0;
          spaces--;
        }
    }
   
        cout<<"Unsolved Sudoku for user  "<<endl;   
        char playersud[17];
        strcpy(playersud,"playersudoku.txt\0");
        f3.open(playersud);//Copies the unsolved version of the sudoku in a file for use in graphics(not anymore)
        for(i=0;i<9;i++)
        {
            
            for(j=0;j<9;j++)
            {
                 f3<<Sudoku[i][j]<<"  ";
            }
            f3<<endl;
        }
        display();
        f3.close();
        break; 

    default :
             cout<<"Invalid option"<<endl;

   }
   return 0;
}
void display()//Displays a nice board
{
     cout << "    1 2 3  |  4 5 6  |  7 8 9\n"
          << "--------------------------------\n\n";
          for (int k = 3;k<=9;k+=3)
          {
              for (int i = k-3;i<k;i++)
              {
                  cout << i+1 << "|  ";
                  for (int j = 0;j<3;j++)
                  {
                       cout <<Sudoku[i][j] << " ";
                  }
                  cout << " |  ";
                  for (int j=3;j<6;j++)
                  {
                       cout <<Sudoku[i][j] << " ";
                  }
                  cout << " |  ";
                  for (int j=6;j<9;j++)
                  {
                        cout <<Sudoku[i][j] << " ";
                  }
                  cout << " |  ";  
                  cout << endl;
              }
              cout << endl << "--------------------------------\n\n";
          }
}

//Code complete
